> For the complete documentation index, see [llms.txt](https://docs.tokensfarm.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tokensfarm.com/for-developers/integrate-tokensfarm/tokensfarm-contract-interface.md).

# TokensFarm Contract Interface

```solidity
interface ITokensFarm {
    function deposit(uint256 _amount) external;
    function withdraw(uint256 _amount, uint256 stakeId) external;
    function getUserStakesAndPendingAmounts(address user) external view;
    function getTotalRewardsLockedUnlocked() external view returns (uint256, uint256);
    function deposited(address _user, uint256 stakeId) public view;
    function pending(address _user, uint256 stakeId) public view;
    function totalPending() external view;
    function getNumberOfUserStakes(address user) external view;
    function fund(uint256 _amount) external;
    function emergencyWithdraw(uint256 stakeId) external;
    function updatePool() public;
    function depositTimestamp(address _user, uint256 stakeId) public view;
    function withdrawTimestamp(address _user, uint256 stakeId) public view;
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.tokensfarm.com/for-developers/integrate-tokensfarm/tokensfarm-contract-interface.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
